"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
api - bitdrift's client/server API definitions
Copyright Bitdrift, Inc. All rights reserved.

Use of this source code and APIs are governed by a source available license that can be found in
the LICENSE file or at:
https://polyformproject.org/wp-content/uploads/2020/06/PolyForm-Shield-1.0.0.txt
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _MetricPlatformType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _MetricPlatformTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_MetricPlatformType.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    UNSPECIFIED: _MetricPlatformType.ValueType  # 0
    APPLE: _MetricPlatformType.ValueType  # 1
    ANDROID: _MetricPlatformType.ValueType  # 2
    ELECTRON: _MetricPlatformType.ValueType  # 3

class MetricPlatformType(_MetricPlatformType, metaclass=_MetricPlatformTypeEnumTypeWrapper): ...

UNSPECIFIED: MetricPlatformType.ValueType  # 0
APPLE: MetricPlatformType.ValueType  # 1
ANDROID: MetricPlatformType.ValueType  # 2
ELECTRON: MetricPlatformType.ValueType  # 3
global___MetricPlatformType = MetricPlatformType

@typing.final
class IngestMetricRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    METRIC_ID_FIELD_NUMBER: builtins.int
    PLATFORM_TYPE_FIELD_NUMBER: builtins.int
    APP_ID_FIELD_NUMBER: builtins.int
    APP_VERSION_FIELD_NUMBER: builtins.int
    TIMESTAMP_FIELD_NUMBER: builtins.int
    COUNTER_DELTA_FIELD_NUMBER: builtins.int
    metric_id: builtins.str
    """The metric ID that this ingestion request applies to. This ingestion ID will be made available
    in different ways depending on the integration point. See the product documentation for
    when and how this should be used.
    """
    platform_type: global___MetricPlatformType.ValueType
    """Metrics must have an attached platform type. For server-side integrations, the platform must
    be propagated from the client. UNSPECIFIED is not a valid platform type and will result in an
    error.
    """
    app_id: builtins.str
    """Metrics must have an attached app_id. For server-side integrations, the app_id must be
    propagated from the client.
    """
    app_version: builtins.str
    """Metrics must have an attached app_version. For server-side integrations, the app_version
    must be propagated from the client.
    """
    counter_delta: builtins.int
    """Increments an integer counter by the supplied delta. If the metric_id does not point to a
    counter, this request will fail.
    """
    @property
    def timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """An optional timestamp that the metric should be recorded at. If not supplied, defaults to
        the current server time.
        """

    def __init__(
        self,
        *,
        metric_id: builtins.str = ...,
        platform_type: global___MetricPlatformType.ValueType = ...,
        app_id: builtins.str = ...,
        app_version: builtins.str = ...,
        timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        counter_delta: builtins.int = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["counter_delta", b"counter_delta", "metric_value_type", b"metric_value_type", "timestamp", b"timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["app_id", b"app_id", "app_version", b"app_version", "counter_delta", b"counter_delta", "metric_id", b"metric_id", "metric_value_type", b"metric_value_type", "platform_type", b"platform_type", "timestamp", b"timestamp"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["metric_value_type", b"metric_value_type"]) -> typing.Literal["counter_delta"] | None: ...

global___IngestMetricRequest = IngestMetricRequest

@typing.final
class IngestMetricResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___IngestMetricResponse = IngestMetricResponse
